package edu.chl.hajo.monopoly.core;

import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeSupport;

import edu.chl.hajo.monopoly.constants.Piece;
import edu.chl.hajo.monopoly.constants.StateChanges;
import edu.chl.hajo.monopoly.util.IObservable;

public class Player implements IObservable {

	private final PropertyChangeSupport observers = new PropertyChangeSupport(this);
	private final Piece piece;
	private int position = 0;
	private int oldPosition = 0;
	private String name;
	

	public Player(String name, Piece piece) {
		this.name = name;
		this.piece = piece;
		
	}

	public void setPosition(int position) {
		this.oldPosition = this.position;
		this.position = position;
		observers.firePropertyChange(
				StateChanges.PLAYER_POSITION.toString(), oldPosition,
				position);	
	}

	
	public Piece getPiece() {
		return piece;
	}
	
	public String getName() {
		return name;
	}

	@Override
	public void addObserver(PropertyChangeListener observer) {
		observers.addPropertyChangeListener(observer);
	}

	public int getPosition() {
		return position;
	}
}
