package edu.chl.hajo.monopoly.view;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.ArrayList;
import java.util.List;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.WindowConstants;
import javax.swing.border.LineBorder;

import edu.chl.hajo.monopoly.constants.GameEvents;
import edu.chl.hajo.monopoly.constants.StateChanges;
import edu.chl.hajo.monopoly.core.Game;
import edu.chl.hajo.monopoly.core.IGame;
import edu.chl.hajo.monopoly.core.Player;
import edu.chl.hajo.monopoly.core.Tax;
import edu.chl.hajo.monopoly.core.space.NonProperty;
import edu.chl.hajo.monopoly.core.space.Property;
import edu.chl.hajo.monopoly.core.space.AbstractSpace;
import edu.chl.hajo.monopoly.core.space.Street;
import edu.chl.hajo.monopoly.ctrl.EndRoundCtrl;
import edu.chl.hajo.monopoly.ctrl.MoveCtrl;

/**
 * This code was edited or generated using CloudGarden's Jigloo SWT/Swing GUI
 * Builder, which is free for non-commercial use. If Jigloo is being used
 * commercially (ie, by a corporation, company or business for any purpose
 * whatever) then you should purchase a license for each developer using Jigloo.
 * Please visit www.cloudgarden.com for details. Use of Jigloo implies
 * acceptance of these licensing terms. A COMMERCIAL LICENSE HAS NOT BEEN
 * PURCHASED FOR THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED LEGALLY FOR
 * ANY CORPORATE OR COMMERCIAL PURPOSE.
 */
/**
 * Application main window
 * 
 * @author hajo
 */
@SuppressWarnings("serial")
public class MainFrame extends JFrame implements PropertyChangeListener{
	private JPanel jPnlWest;
	private JPanel jPnlNorth;
	private JPanel jPnlControl;
	private JPanel jPnlPlayers;
	private JLabel jLlbDice;
	private JButton jBtnNext;
	private JButton jBtnThrowDice;
	private JPanel jPnlSouth;
	private JPanel jPnlCenter;
	private JPanel jPnlEast;

	private final List<AbstractSpacePanel> spacePanels = new ArrayList<AbstractSpacePanel>();

	public MainFrame() {
		// TODO clean up
		IGame g = Game.getInstance();
		g.getDices().addObserver(this);
		g.addObserver(this);
		initGUI();
		initSpacePanels();
		// TODO initDicePanel();
		// TODO initInfoPanel();
		initPlayerPanels();
		initCtrls();
	}
	

	@Override
	public void propertyChange(PropertyChangeEvent evt) {
		
		String name = evt.getPropertyName();
		if( name.equals(StateChanges.GAME_NEW_ACTUAL_PLAYER.toString())){
			jBtnThrowDice.setEnabled(true);
			jBtnNext.setEnabled(false);
		}else if( name.equals(GameEvents.DICES_EQUAL.toString())){
			jBtnThrowDice.setEnabled(true);
			jBtnNext.setEnabled(false);
		}
	}

	/*
	 * TODO BAD to use instanceof buy leave for now
	 */
	private void initSpacePanels() {
		List<AbstractSpace> spaces = Game.getInstance().getSpaces();
		for (AbstractSpace s : spaces) {
			// Order matters Street subclass
			if (s instanceof Street) {
				spacePanels.add(new StreetPanel((Street) s));
			} else if (s instanceof NonProperty) {
				spacePanels.add(new NonPropertyPanel((NonProperty) s));
			} else if (s instanceof Property) {
				spacePanels.add(new PropertyPanel((Property) s));
			} else if (s instanceof Tax) {
				// TODO no Tax panel for now
				spacePanels.add(new NonPropertyPanel(new NonProperty("JUNK")));
			} else{
				throw new IllegalArgumentException("Bad Space");
			}
		}

		// TODO Hard coded
		for (int i = 0; i < 11; i++) {
			jPnlNorth.add(spacePanels.get(i));
		}
		for (int i = 11; i < 20; i++) {
			jPnlEast.add(spacePanels.get(i));
		}
		for (int i = 30; i > 19; i--) {
			jPnlSouth.add(spacePanels.get(i));
		}
		for (int i = 39; i > 30; i--) {
			jPnlWest.add(spacePanels.get(i));
		}
	}

	// TODO Move buttons to separate "control" panel (and make it a 
	// listener to enable disable the buttons).
	private void initCtrls() {
		jBtnThrowDice.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				// Order matters must set before move
				jBtnThrowDice.setEnabled(false);
				jBtnNext.setEnabled(true);
				// This will possible change the buttons
				new MoveCtrl().execute();
			}

		});
		jBtnNext.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {
				new EndRoundCtrl().execute();
			}

		});
	}

	// --------- GUI ---------------

	private void initPlayerPanels() {
		List<Player> players = Game.getInstance().getPlayers();
		for (int i = 0; i < 4; i++) {
			PlayerPanel p = new PlayerPanel(players.get(i));
			jPnlPlayers.add(p);
		}
	}

	private void initGUI() {
		// TODO Screen size
		this.setSize(600, 600);
		this.setTitle("Monopoly");
		BorderLayout thisLayout = new BorderLayout();
		getContentPane().setLayout(thisLayout);
		this.setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
		this.addWindowListener(new WindowAdapter() {
		});
		{
			jPnlWest = new JPanel();
			BoxLayout jPnlWestLayout = new BoxLayout(jPnlWest,
					javax.swing.BoxLayout.Y_AXIS);
			jPnlWest.setLayout(jPnlWestLayout);
			getContentPane().add(jPnlWest, BorderLayout.WEST);
		}
		{
			jPnlNorth = new JPanel();
			BoxLayout jPnlNorthLayout = new BoxLayout(jPnlNorth,
					javax.swing.BoxLayout.X_AXIS);
			jPnlNorth.setLayout(jPnlNorthLayout);
			getContentPane().add(jPnlNorth, BorderLayout.NORTH);
		}
		{
			jPnlEast = new JPanel();
			BoxLayout jPnlEastLayout = new BoxLayout(jPnlEast,
					javax.swing.BoxLayout.Y_AXIS);
			jPnlEast.setLayout(jPnlEastLayout);
			getContentPane().add(jPnlEast, BorderLayout.EAST);
		}

		{
			jPnlCenter = new JPanel();
			BorderLayout jPnlCenterLayout = new BorderLayout();
			jPnlCenter.setLayout(jPnlCenterLayout);
			getContentPane().add(jPnlCenter, BorderLayout.CENTER);
		}

		{
			jPnlSouth = new JPanel();
			BoxLayout jPnlSouthLayout = new BoxLayout(jPnlSouth,
					javax.swing.BoxLayout.X_AXIS);
			jPnlSouth.setLayout(jPnlSouthLayout);
			getContentPane().add(jPnlSouth, BorderLayout.SOUTH);
		}

		{
			jPnlControl = new JPanel();
			jPnlPlayers = new JPanel();
			jPnlCenter.add(jPnlControl, BorderLayout.NORTH);
			jPnlCenter.add(jPnlPlayers, BorderLayout.CENTER);
			jPnlControl.setPreferredSize(new java.awt.Dimension(771, 60));
			jPnlControl.setBorder(new LineBorder(new java.awt.Color(0, 0, 0),
					1, false));
			{
				jBtnThrowDice = new JButton();
				jPnlControl.add(jBtnThrowDice);
				jBtnThrowDice.setLayout(null);
				jBtnThrowDice.setText("jBtnThrowDice");
			}
			{
				jBtnNext = new JButton();
				jPnlControl.add(jBtnNext);
				jBtnNext.setText("jBtnNext");
				jBtnNext.setEnabled(false);
			}
			{
				jLlbDice = new JLabel();
				jPnlControl.add(jLlbDice);
				jLlbDice.setText("jLlbDice");
			}
		}

	}


}
