package edu.chl.hajo.monopoly.view;

import java.awt.Color;
import java.awt.Graphics;
import java.beans.PropertyChangeEvent;

import edu.chl.hajo.monopoly.constants.Piece;
import edu.chl.hajo.monopoly.constants.StateChanges;
import edu.chl.hajo.monopoly.core.space.Property;
import edu.chl.hajo.monopoly.view.details.PropertyDetails;
/**
 * Display of Property
 * @author hajo
 *
 */
@SuppressWarnings("serial")
public class PropertyPanel extends AbstractSpacePanel {
	
	private Property property;
	
	protected void showDetails(){
		new PropertyDetails(this, property).setVisible(true);
	}
	
	public PropertyPanel(Property property) {
		super(property);
		this.property = property;
	}
	
	private Color backGround = this.getBackground();
	
	@Override
	public void propertyChange(PropertyChangeEvent evt) {
		super.propertyChange(evt);
		String name = evt.getPropertyName();
		if (StateChanges.PROPERTY_GOT_OWNER.toString().equals(name)) {
			setColorForOwner(property.getOwner().getPiece());
			//this.setBackground(property.getOwner().getColor());
		} else if (StateChanges.PROPERTY_LOST_OWNER.toString().equals(name)) {
			this.setBackground(backGround);
		}
	}
	
	private void setColorForOwner(Piece p){
			// TODO hard coded should be read from config/options
			switch (p) {
			case DOG:this.setBackground(Color.YELLOW); break;
			case TOP_HAT:this.setBackground(Color.GREEN);break;
			case CAR:this.setBackground(Color.LIGHT_GRAY);break;
			case IRON:this.setBackground(Color.PINK);break;
			default:
			}
	}
	
	@Override
	public void paintComponent(Graphics g) { 
		 super.paintComponent(g);
	 }
}
