package edu.chl.hajo.monopoly;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.ArrayList;
import java.util.List;

import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;

import edu.chl.hajo.monopoly.constants.Piece;
import edu.chl.hajo.monopoly.constants.StateChanges;
import edu.chl.hajo.monopoly.core.Game;
import edu.chl.hajo.monopoly.core.IGame;
import edu.chl.hajo.monopoly.core.Player;

public class TestEvents {
	
	private IGame g;
	private String name;  // Of events
	
	private PropertyChangeListener observer = new PropertyChangeListener() {
		
		@Override
		public void propertyChange(PropertyChangeEvent evt) {
			name = evt.getPropertyName();	
		}
	};

	@Before
	// Run before each test method
	public void setUpBefore() throws Exception {
		List<Player> p = new ArrayList<Player>();
		// Ordering matters! Use buy game
		p.add(new Player("Olle", Piece.DOG));
		p.add(new Player("Fia", Piece.CAR));
		p.add(new Player("Pelle", Piece.TOP_HAT));
		p.add(new Player("Sanna", Piece.IRON));

		g = Game.getInstance();
		((Game) g).init(p);
	}

	@Test
	public void testStateChangesGame() {
		g.addObserver(observer);
		g.switchActualPlayer();
		
		Assert.assertTrue(name.equals(StateChanges.GAME_NEW_ACTUAL_PLAYER.toString()));
		
	}
	
	// TODO @Test
	public void testStateChangesSpace () {
		
	}
}
