package edu.chl.hajo.monopoly.core;

import java.util.List;

import edu.chl.hajo.monopoly.util.PlayerData;

/**
 * Interface for the game. 
 * This is an DDD interface (no controllers)
 * 
 * @author hajo
 * 
 */
public interface IGame {

	public abstract void setPlayers(List<PlayerData> datum);

	public abstract void setRules(String rulesName);

	public abstract void killPlayer();

	public abstract void chanceCommunity();

	public abstract void endTurn();

	// This is an bootstrap interface. Sub interfaces
	public abstract IRules getRules();

	public abstract IPlayer getPlayer();
	
}