package edu.chl.hajo.monopoly;

import java.util.ArrayList;
import java.util.List;

import org.junit.Assert;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

import edu.chl.hajo.monopoly.build.GameBuilder;
import edu.chl.hajo.monopoly.constants.Piece;
import edu.chl.hajo.monopoly.core.Board2;
import edu.chl.hajo.monopoly.core.Dices;
import edu.chl.hajo.monopoly.core.IGame;
import edu.chl.hajo.monopoly.core.Player;
import edu.chl.hajo.monopoly.event.EventBus;
import edu.chl.hajo.monopoly.util.PlayerData;

/**
 * Here we have a fat model, lot to test.
 * 
 * But this is a bit cumbersome because we have to build the complete
 * model. We would like to test each class as isolated as possible.
 * 
 * @author hajo
 *
 */
public class TestPlayer {
	
	// Just so we don't need to use the Locator 
	// in the test methods
	static IGame g;
	
	// Must be run once (BeforeClass), can't call
	// Locator.set() multiple times
	@BeforeClass
	public static void setUpClass() throws Exception {
		g = new GameBuilder().build();
	}
	
	// Called before every method, fresh data
	// All player at GO (position 0) with balance 1000
	@Before
	public void setUp(){
		List<PlayerData> ps = new ArrayList<PlayerData>();
		int b =  1000;
		ps.add(new PlayerData("Olle", Piece.DOG, b, false, null));
		ps.add(new PlayerData("Fia", Piece.TOP_HAT, b, false, null));
		ps.add(new PlayerData("Pelle", Piece.CAR, b, false, null));
		ps.add(new PlayerData("Sanna", Piece.IRON, b, false, null));
		// No events for now
		EventBus.getInstance().on(false);
		g.setPlayers(ps);
	}
	
	Board2 board;
	Dices dices;
	
	@Test
	public void testMove() {
		// We'll test the implementation
		Player p = (Player) g.getPlayer();
		p.move(1);	
		Assert.assertTrue(p.getPosition() == 1);
		
		
	}

	
}
