package edu.chl.hajo.monopoly.core;

import java.util.Random;

import edu.chl.hajo.monopoly.constants.GameEvents;
import edu.chl.hajo.monopoly.constants.StateChanges;
import edu.chl.hajo.monopoly.event.EventBus;


/**
 * A pair of dices
 * 
 * @author hajo
 * 
 */
public class Dices  {
	
	private static final Random r = new Random();
	private int fst = 0;
	private int sec = 0;
	private int nEquals = 0; // 3 equal => go jail
	private EventBus eb = EventBus.getInstance();

	public int roll() {
		fst = r.nextInt(6) + 1;
		sec = r.nextInt(6) + 1;
		fire();
		// Not a state change just something that can happen
		if (fst == sec) {
			nEquals++;
			eb.broadcast(GameEvents.DICES_EQUAL, null, null);
			// Rules say if 3 equals go to jail
			if (nEquals == 3) {
				eb.broadcast(GameEvents.GO_JAIL, null, null);
				nEquals = 0;
			}
		}else {
			nEquals = 0;
		}
		return fst + sec;
	}
	
	private void fire() {
		eb.broadcast(StateChanges.DICE_FST_THROWN, null, fst);
		eb.broadcast(StateChanges.DICE_SEC_THROWN, null, sec);	
	}


	public void reset() {
		fst = sec = 0;
		fire();
	}

	public boolean areEqual() {
		return fst == sec;
	}
	
	// Testing
	public int rollNonEqual() {
		roll();
		if( areEqual() ){
			fst++;
		}
		return fst+sec;
	}
}
