package edu.chl.hajo.monopoly.ctrl;

import edu.chl.hajo.monopoly.core.Bank;
import edu.chl.hajo.monopoly.core.Building;
import edu.chl.hajo.monopoly.core.Player;
import edu.chl.hajo.monopoly.core.space.Street;
import edu.chl.hajo.monopoly.rules.Rules;

/**
 *  Control
 */
class BuyBuildingCtrl extends AbstractControl{

	private Street street;

	public BuyBuildingCtrl(Street street) {
		this.street = street;
	}

	public void execute() {
		
		if( !Rules.buyBuildingEnabled(street)){
			return;
		}
		
		Player p = g.getActualPlayer();
		Building b = Bank.getBuilding();
		/*
		 * If can't buy this nothing happens
		 * So can use p.withDraw
		 */
		if (p.getBalance() >= b.getPrice()) {
			street.addBuilding(b);
			p.withDraw(b.getPrice());
		} else {
			g.message("no_money");
		}
	}

}
