package edu.chl.hajo.monopoly.ctrl;

import edu.chl.hajo.monopoly.core.Player;
import edu.chl.hajo.monopoly.core.space.Property;
import edu.chl.hajo.monopoly.rules.Rules;

/**
 *  Control
 */
class BuyPropertyCtrl extends AbstractControl{

	private Property property;

	public BuyPropertyCtrl(Property property) {
		this.property = property;
	}
	
	public void execute() {
	
		// Blocked by GUI but with this we can test!!
		if( !Rules.buyEnabled(property)){
			return;
		}
		
		Player p = g.getActualPlayer();
		/*
		 * If can't buy nothing happens
		 * So can use p.withDraw
		 */
		if (p.getBalance() >= property.getPrice()) {
			p.withDraw(property.getPrice());
			property.setOwner(p);
			p.addProperty(property);
		} else {
			g.message("no_money");
		}
	}
}
