package edu.chl.hajo.monopoly.ctrl;

/**
 *  Control. Design decision to have one control for most
 *  possible actions when hitting a Chance or Communitiy
 *  space.
 *  See also GetFromAllCtrl
 *
 * Data format
 * text:action:arg
 * 
 * text:
 * String to display //TODO replace with key to later retrieve text
 * 
 * action: 
 * withdraw
 * addIncome
 * move
 * moveTo
 * goJail
 * getFromAll
 * 
 * arg:
 * numerical
 * 
 * @author hajo
 *
 */

class ChanceCommunityCtrl implements IControl{
	
	private String data;
	
	public ChanceCommunityCtrl(String data) {
		this.data = data;
	}

	// Not so object oriented, possible one object for
	// each action
	@Override
	public void execute() {
		String action = data.split(":")[1];
		int arg = Integer.valueOf(data.split(":")[2]);
		
		// TODO move doesn't exist
		if( action.equals("move") ){
			new MoveCtrl(arg).execute();
		}else if (action.equals("moveTo")){
			new MoveCtrl(arg).execute();
		}else if (action.equals("goJail")){
			new GoJailCtrl().execute();
		}else if (action.equals("withdraw")){
			 new ForceWithDrawCtrl(arg).execute();
		}else if (action.equals("getFromAll")){	
			 new GetFromAllCtrl(arg).execute();
		}else{
			throw new IllegalArgumentException( action );
		}
	}
}
