package edu.chl.hajo.monopoly.ctrl;

import edu.chl.hajo.monopoly.core.Dices;
import edu.chl.hajo.monopoly.core.Player;
import edu.chl.hajo.monopoly.core.space.AbstractSpace;
import edu.chl.hajo.monopoly.util.Config;

/**
 *  Control. Move player
 */
class MoveCtrl extends AbstractControl{

	private Dices dices;

	public MoveCtrl() {
		dices = g.getDices();
	}

	// -------- Testing, debug -----------------
	private int steps;

	public MoveCtrl(int steps) {
		this.steps = steps;
	}
	// Possible to get dices non equal
	private boolean equals = true;
	public MoveCtrl(boolean equals){
		this.equals = equals;
	}
	// ---- End ------------------

	public void execute() {
		Player p = g.getActualPlayer();

		AbstractSpace s = g.getActualSpace();
		s.removeVisitingPlayer(p);

		/*
		 * This is for testing
		 */
		// If steps not specified (=0) get random
		if (steps == 0) {
			if( equals ){
				// Normal case, get random steps
				steps = g.getDices().roll();
			}else{
				// Testing, dices never equal
				steps = g.getDices().rollNonEqual();
			}
		}
		int oldPos = p.getPosition();
		int pos = (oldPos + steps) % 40;
		if (!p.isInJail()) {
			p.moveTo(pos);
		} else {
			if (dices.areEqual()) {
				p.moveTo(pos);
				p.inJail(false);
			}
		}
		// Completed a lap
		if( pos <= oldPos ){
			p.addIncome(Config.getPassGoIncome());
		}
		
		s = g.getActualSpace();
		s.addVisitingPlayer(p);
	}
}