package edu.chl.hajo.monopoly.core;

import edu.chl.hajo.monopoly.core.card.Card;
import java.util.LinkedList;
import java.util.List;
import java.util.Queue;

/**
 * Class used for both the decks (Chance and Community Chest)
 *
 * @author hajo
 *
 */
public class Deck {

    private final Queue<Card> cards = new LinkedList<>();

    public Deck(List<Card> cards) {
        for (Card c : cards) {
            this.cards.add(c);
        }
    }

    public Card pickCard() {
        // Shuffle cards in circle
        Card c = cards.remove();
        cards.add(c);
        return c;
    }

}
