package edu.chl.hajo.monopoly.gui;

import edu.chl.hajo.monopoly.core.IMonopoly;
import edu.chl.hajo.monopoly.core.MonopolyOptions;
import edu.chl.hajo.monopoly.core.Player;
import edu.chl.hajo.monopoly.event.Event;
import edu.chl.hajo.monopoly.event.EventBus;
import edu.chl.hajo.monopoly.event.IEventHandler;
import java.awt.Color;
import java.awt.Component;
import java.awt.GridLayout;
import java.util.HashMap;
import java.util.Map;
import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JPanel;

/**
 * A view of *all* the players
 * @author hajo
 */
public class PlayersPanel extends JPanel implements IEventHandler {

    // Inner class, view of single player
    private static class PlayerPanel extends JPanel {

        private final JLabel name = new JLabel();
        private final JLabel balance = new JLabel();
        private final JLabel debt = new JLabel();

        public PlayerPanel(Player p) {
            this.setLayout(new GridLayout(5, 1));
            this.setBorder(BorderFactory.createLineBorder(Color.RED));
            this.name.setText(p.getName());
            this.balance.setText(String.valueOf(p.getBalance()));
            this.debt.setText(String.valueOf(p.hasDebt()));

            this.add(name);
            this.add(balance);
            this.add(debt);
            this.setSize(60, 40);
        }

    };

    public PlayersPanel() {
        this.setLayout(new GridLayout(1, MonopolyOptions.getNPlayers()));
        EventBus.INSTANCE.register(this);
    }

    // Given a player lookup it's view
    Map<Player, PlayerPanel> map;

    @Override
    public void onEvent(Event evt) {
        switch (evt.getTag()) {
            case NEW_GAME:
                map = new HashMap<>();
                IMonopoly m = (IMonopoly) evt.getValue();
                for (Player p : m.getPlayers()) {
                    PlayerPanel pp = new PlayerPanel(p);
                    map.put(p, pp);
                    this.add(pp);
                }
                break;
            case NEXT:
                for( Component c : getComponents()){
                    c.setBackground(Color.LIGHT_GRAY);
                }
                Player actual =  (Player) evt.getValue();
                PlayerPanel pp = map.get(actual);
                pp.setBackground(Color.YELLOW);
                break;
            default: ;
        }

    }

}
