package edu.chl.hajo.mply.core;

/**
 * Piece to move around board
 * 
 * @author hajo
 * 
 */
public class Piece {
    
    public enum Tag {
        DOG, TOP_HAT, CAR, IRON,
    }

    private final Player owner;
    private final Tag tag; // TODO inner enum
    private int pos = 0;
    // Two states, possible to move or not
    private boolean movable = true;

    public Piece(Player player, Piece.Tag tag) {
        super();
        this.owner = player;
        this.tag = tag;
    }

    // TODO Is it better to return new pos??
    public int move(int steps) {
        int oldPos = pos;
        if( !movable){
            return oldPos;
        }
        pos = (pos + steps) % P.INSTANCE.getMaxSpaces();
        // Max move is 12 (in general)
        
        movable = (steps < P.INSTANCE.getMaxDice()) ? false : true;
        return pos;
    }
    
    public void setMovable(boolean b){
        movable = b;
    }
    
    public boolean isMovable(){
        return movable;
    }
    
   
    public int getPosition() {
        return pos;
    }

    public Player getPlayer() {
        return owner;
    }

    public Piece.Tag getTag() {
        return tag;
    }
}
