package edu.chl.hajo.mply.core;

import edu.chl.hajo.mply.event.Event;
import edu.chl.hajo.mply.event.EventBus;

/**
 * A player
 * 
 * @author hajo
 * 
 */

public class Player {

    private String name;
    private int balance;
    private boolean inJail = false;

    public Player(String name) {
        this.name = name;
    }

    public String getName() {
        return name;
    }

    public void income(int income) {
        setBalance(balance + income);
    }

    public void expense(int expence) {
        if (expence > balance) {
            // TODO have to handle
        }
        setBalance(balance - expence);
    }

    // TODO doesn't work for jail handling
    public int roll(Dice d) {
        int i = d.roll();
        if( !inJail ){
            return i;
        }else{
            if( i == P.INSTANCE.getMaxDice()){
                inJail = false;
                return i;
            }else{
                return 0;
            }
        }
    }

    @Override
    public String toString() {
        return "P[" + name + "," + balance + "," + inJail +"]";
    }

   
    public void sell(Space space) {
        space.setOwner(null);
    }

    public void buy(Space space) {
        space.setOwner(this);
    }
    
    public void freeFromJail(){
        inJail = false;
    }

    public void actOnCard(Card c) {
        if (c.getAction() == Card.Action.INCOME) {
            income(c.getArg());
        } else if (c.getAction() == Card.Action.EXPENCE) {
            expense(c.getArg());
        } else if (c.getAction() == Card.Action.JAIL) {
            inJail = true;
        } else{
            
        }
    }

    // Events ------
    
    public void pickCard(CardBundle bundle) {
       // TODO store card
       EventBus.publish(new Event(Event.Tag.CARD, bundle.getCard()));    
    }
    
    private void setBalance(int balance) {
       this.balance = balance; 
       EventBus.publish(new Event(Event.Tag.PLAYER_BALANCE, balance));
     }
}
