package edu.chl.hajo.mply.event;

/**
 * A single event
 * @author hajo
 *
 */
public class Event {
    // All possible events listed
    public enum Tag {
        PIECE_OLD_POSITION,
        PIECE_NEW_POSITION,
        PIECE_MOVABLE,
        PLAYER_BALANCE,
        DICE_VALUE,
        GAME_NEXT_PLAYER,
        SPACE_GOT_OWNER,
        SPACE_LOST_OWNER, 
        CARD, 
    }
    private final Tag tag;
    // The new value 
    private final Object value;
    public Event(Tag tag, Object value){
        this.tag = tag;
        this.value = value;
    }
    public Tag getTag() {
        return tag;
    }
    public Object getValue() {
        return value;
    }
    @Override
    public String toString() {
        return "Event [tag=" + tag + ", value=" + value + "]";
    } 
    
    
}
