package monopoly01alt;

import java.util.HashSet;
import java.util.Set;

/**
 * 
 * This is where the player move around (streets, railroads, corners, jail,
 * etc..)
 * 
 * @author hajo
 * 
 */
public class Space {

    private final Set<Player> visitors = new HashSet<>();
    private final String name;
    private Player owner;
    private final int rent;

    public Space(String name, int rent) {
        this.name = name;
        this.rent = rent;
    }

    public boolean isVisitor(Player p) {
        return visitors.contains(p);
    }

    public void removeVisitor(Player p) {
        visitors.remove(p);
    }

    public void addVisitor(Player p) {
        visitors.add(p);
    }

    @Override
    public String toString() {
        StringBuffer b = new StringBuffer();
        b.append(name + "(");
        for (Player p : visitors) {
            if (p != null) {
                b.append(p.toString() + ",");
            }
        }
        b.append(")");
        return b.toString();
    }

    public void setOwner(Player owner) {
        this.owner = owner;
    }

    public Player getOwner() {
        return owner;
    }

    public int getRent() {
        return rent;
    }
}
