package edu.chl.hajo.monopoly04.model;

import java.util.Collection;
import java.util.Collections;
import java.util.List;



/**
 * 
 * The board holding spaces having players
 * 
 * @author hajo
 * 
 */

public class Board implements IBoard {

    private final List<Space> spaces;

    public Board(List<Space> spaces) {
        this.spaces = spaces;
    }

    public Space get(Space s, int steps) {
        int i = spaces.indexOf(s);
        return spaces.get((i + steps) % spaces.size() );
    }

    public Collection<Space> getSpaces() {
        return Collections.unmodifiableCollection(spaces);
    }

    public Space remove(Player p) {
        Space found = null;
        for (Space s : spaces) {
            if (s.isVisitor(p)) {
                found = s;
            }
        }
        if (found != null) {
            found.removeVisitor(p);
        }
        return found;
    }
    
    @Override
    public String toString(){
        StringBuffer b = new StringBuffer();
        b.append("[");
        for( Space s : spaces){
            b.append(s.toString());
        }
        b.append("]");
        return b.toString();
    }

   
    
}
