package edu.chl.hajo.monopoly04.view;

import java.awt.GridLayout;
import java.util.Collection;

import javax.swing.JPanel;

import edu.chl.hajo.monopoly04.eventbus.EventBus;
import edu.chl.hajo.monopoly04.model.IBoard;
import edu.chl.hajo.monopoly04.model.Space;

/**
 * Container for SpacePanels
 * @author hajo
 *
 */

@SuppressWarnings("serial")
public class BoardPanel extends JPanel {
   
    public  BoardPanel(IBoard board){
        Collection<Space> spaces = board.getSpaces();
        this.setLayout(new GridLayout(1, spaces.size()));
        for (Space s : spaces) {
            SpacePanel sp = new SpacePanel(s.getName());
            this.add(sp);
            EventBus.INSTANCE.register(sp);
        }
   }
}
