package edu.chl.hajo.monopoly04.view;

import java.awt.Color;
import java.awt.GridLayout;

import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JPanel;

import edu.chl.hajo.monopoly04.eventbus.Event;
import edu.chl.hajo.monopoly04.eventbus.IEventHandler;
import edu.chl.hajo.monopoly04.model.Player;

/**
 * View of single Player
 * @author hajo
 *
 */
@SuppressWarnings("serial")
public class PlayerPanel extends JPanel implements IEventHandler {
    JLabel name = new JLabel();
    private final String playerName;

    public PlayerPanel(String name) {
        this.playerName = name;
        this.setLayout(new GridLayout(4, 1));
        this.name.setText(name);
        this.add(this.name);
        this.setBorder(BorderFactory.createLineBorder(Color.black));
        this.setBackground(Color.LIGHT_GRAY);
    }

    @Override
    public void onEvent(Event evt) {
        if (evt.getTag() == Event.Tag.END_TURN) {
            Player p = (Player) evt.getValue();
            if( p.getName().equals(playerName)){
                this.setBackground(Color.YELLOW);
            }else{
                this.setBackground(Color.LIGHT_GRAY);
            }
        }
        
    }
}
