package cdi;

import org.jboss.weld.environment.se.Weld;
import org.jboss.weld.environment.se.WeldContainer;

/**
 * Using Java Context and Dependency Injectio (CDI)
 * (implementas as weld library)
 * @author hajo
 *
 * NOTE: CDI SE applications can be bootstrapped by running 
 * the StartMain class like so: java org.jboss.weld.environments.se.StartMain <args>
 * See Chapter 11 of Weld Reference 
 */

public class Main {

	public static void main(String[] args) {
		WeldContainer wc = new Weld().initialize();
		// Create Main
		// wc.instance().select(Main.class).get();
		// Other way to do it
		Person p = wc.instance().select(Person.class).get();
		
		
		@SuppressWarnings("unused")
		MainFrame mf = wc.instance().select(MainFrame.class).get();
		
		
		ShoppingCart sc = p.getShopingCart();
		sc.addItem(new Item("Cheese"));
		
		//w.shutdown(); Seems not to be needed? 
	}
}
