package edu.chl.hajo.test.list;

/**
 * A list with positive integers, implemented as a chain of Nodes, each holding
 * an integer value.
 * 
 * @author hajo
 * 
 */
public class List {
    /*
     * This isn't used to store data just to make an empty list contain a start
     * node (instead of null) Always first in list
     */
    private final Node<Integer> head = new Node<Integer>(null, null, -1);
    // The number of nodes (except head) in list
    private int length = 0;

    /**
     * Add an integer to the list (add a node first (after head) in list).
     * @param n
     */
    public void add(Integer i) {
        if (i < 0) {
            throw new IllegalArgumentException("Only positive values allowed");
        }
        Node<Integer> tail = head.getNext();
        Node<Integer> n = new Node<Integer>(head, tail, i);
        head.setNext(n);
        length++;
    }

    /**
     * Remove a integer from list (remove a node)
     * @return, the removed value
     */
    public Integer remove() {
        if (length == 0) {
            throw new IllegalStateException("List empty");
        }
        Integer i = head.getNext().getValue();
        head.setNext(head.getNext().getNext());
        return i;
    }

    /**
     *  Get value for selected index
     *  We start with index 0
     *  @return, value for selected index
     *  @throws, IllegaArgumenttlException if index out of bounds
     */  
    public Integer get(int index) {
        if (index < 0 || index >= length) {
            throw new IllegalArgumentException("Index out of bound");
        }
        Node<Integer> pos = head;
        for (int i = 0; i < index; i++) {
            pos = pos.getNext();

        }
        return pos.getValue();
    }

    /**
     * Make a deep copy of list
     * @return, the copy.
     */
    public List copy() {
       // TODO 
    	return null;
    }

    public int getLength() {
        return length;
    }

   
}
